#include <stdio.h>
#include <X11/X.h>
#include <X11/Xos.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include "dat.h"
#include "fns.h"
#include "config.h"

extern int cycling;

void initkeys (void) {
	XGrabKey(dpy, XKeysymToKeycode(dpy,XK_Return), HOTKEY_MOD, screens[0].root, True, GrabModeAsync, GrabModeAsync);
}

void key (XKeyEvent *e) {
	Client *c;
	ScreenInfo *s;

	s = getscreen(e->root);
	if (s == 0)
		return;

	curtime = e->time;
	if (getscreen(e->root) == 0)
		return;
	c = getclient(e->window, 0);

	switch (XKeycodeToKeysym(dpy,e->keycode,0)) {
	case XK_Up:
	case XK_KP_Up:
		move(c, 0, 1, 0, -16); break;
	case XK_Down:
	case XK_KP_Down:
		move(c, 0, 1, 0, 16); break;
	case XK_Left:
	case XK_KP_Left:
		move(c, 0, 1, -16, 0); break;
	case XK_Right:
	case XK_KP_Right:
		move(c, 0, 1, 16, 0); break;
	case XK_KP_Insert:
		resize(c, 0); break;
	/* not much use for this, really...
	 * case XK_KP_Delete:
	 * 	move(c, 0, 1, 0, 0); break; */
	case XK_Home:
	case XK_KP_Home:
		move(c, 0, 0, BORDER-1, BORDER-1); break;
	case XK_End:
	case XK_KP_End:
		move(c, 0, 0, BORDER-1, DisplayHeight(dpy, c->screen->num)-c->dy-BORDER); break;
	case XK_Page_Up:
	case XK_KP_Page_Up:
		move(c, 0, 0, DisplayWidth(dpy, c->screen->num)-c->dx-BORDER+1, BORDER-1); break;
	case XK_Page_Down:
	case XK_KP_Page_Down:
		move(c, 0, 0, DisplayWidth(dpy, c->screen->num)-c->dx-BORDER+1, DisplayHeight(dpy, c->screen->num)-c->dy-BORDER); break;
	case XK_Return:
		spawn(s); break;
	case CYCLE_KEY:
		cycle(!((e->state&ControlMask)==ControlMask)); break;
	case XK_Escape:
		delete(c, (e->state&ShiftMask)==ShiftMask); break;
	case XK_h:
		hide(c); break;
	default:
	}
}

void grabkeys (Client *c) {
	if (cycling)
		return;
	XUngrabKeyboard(dpy, CurrentTime);
	XGrabKey(dpy, AnyKey, HOTKEY_MOD, c->parent, True, GrabModeAsync, GrabModeAsync);
	XGrabKey(dpy, XKeysymToKeycode(dpy, CYCLE_KEY), CYCLE_MOD, c->parent, True, GrabModeAsync, GrabModeAsync);
}
